#
# spec file for package smatch
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           smatch
Version:        20181114
Release:        1.1
Summary:        Static analysis tool for C
License:        GPL-2.0-only
Group:          Development/Tools/Building
URL:            http://smatch.sf.net
Source:         %{name}-%{version}.tar.xz
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  pkgconfig
BuildRequires:  sqlite3-devel
BuildRequires:  xz

%description
Smatch is a static analysis tool for C. Most of the checks are for the linux
kernel. Please write checks for your project. It's fun and easy!

%prep
%setup -q

%build
make %{?_smp_mflags} CFLAGS="%{optflags}" INSTALL_PREFIX=%{_prefix} LIBDIR=%{_libdir} \
	PKGCONFIGDIR=%{_datadir}/pkgconfig

%install
%{makeinstall} INSTALL_PREFIX=%{_prefix} LIBDIR=%{_libdir} \
	PKGCONFIGDIR=%{_datadir}/pkgconfig

# sparse stuff
rm -rf %{buildroot}/%{_bindir}/cgcc
rm -rf %{buildroot}/%{_includedir}/sparse
rm -rf %{buildroot}/%{_libdir}/*a
rm -rf %{buildroot}/%{_mandir}/man*/{sparse,cgcc}*
rm -rf %{buildroot}/%{_datadir}/pkgconfig

%files
%defattr(-,root,root)
%license LICENSE
%doc Documentation/smatch*
%{_bindir}/smatch
%{_datadir}/%{name}

%changelog
* Thu Nov 22 2018 Martin Pluskal <mpluskal@suse.com>
- Update to version 20181114:
  * trinity: Proof of concept to auto-generate trinity spec files
  * user_data: rename to smatch_kernel_user_data.c
  * assigned_expr: rename to smatch_assigned_expr.c
  * smatch: make the --enable/disable options take strings
  * clock() is already defined on illumos, so rename the local function.
  * Ignore "#ident" as found in some old sources.
  * Use $(CFLAGS) when compiling smatch.c itself.
  * smatch_nul_terminated: fix compile
  * untracked_param: fix a NULL dereference
  * uninitialized: fix a crashing bug parsing "return (foo);"
  * nul_terminator: track when strings have a NUL terminator
  * and many more small fixes and updates
* Fri Mar 23 2018 dsterba@suse.cz
- Update to version 20180125
* Wed Aug 10 2016 jslaby@suse.com
- Update to version 20160715:
  * capped: set it to uncapped if it's modified
  * smatch.h: silence a compile warning
  * smatch.h: shuffle some declarations around
  * smatch.h: reserve some db types for later
  * *new* continue_vs_break: complain if continue is used in a do {} while (0)
  * smatch_address: don't crash on invalid code
  * continue_vs_break: add it checklist.h
  * dma_mapping_error: add pci_dma_mapping_error() to this check
  * user_data: short circuit a bunch of code
  * debug: add a __smatch_absolute()
* Wed Mar  9 2016 jslaby@suse.com
- update to 20160307
* Wed Dec 16 2015 jslaby@suse.com
- update to 20151208
* Fri Oct  9 2015 jslaby@suse.com
- initial package (taken over from morbidrsa)
